using System.ComponentModel.DataAnnotations;
using Microsoft.AspNetCore.Components;
using VeraxShield.modele.utilisateurs;
using VeraxShield.services.UtilisateursDataService;

namespace VeraxShield.composants.formulaires.modeles.attributsValidationCustoms
{
    public class PseudoCorrectAttribute : ValidationAttribute
    {
        public static List<Utilisateur> TouslesUtilisateurs {get; set;}


        protected override ValidationResult? IsValid(object? value, ValidationContext validationContext)
        {
            bool pseudoExisteDeja = false;
            var pseudo = (string)value;

            foreach (Utilisateur u in PseudoCorrectAttribute.TouslesUtilisateurs)
            {
                if (u.Pseudo == pseudo)
                {
                    pseudoExisteDeja = true;
                }
            }

            if (pseudoExisteDeja)
            {
                return new ValidationResult("Le pseudo existe deja, choississez en un autre.");
            }

            return ValidationResult.Success;
        }

        public static void Initialiser(List<Utilisateur> liste)
        {
            PseudoCorrectAttribute.TouslesUtilisateurs = liste;
        }
    }
}